<?php
namespace mysterious\productlayout\classes;
use function mysterious\productlayout\productLayoutWPB;
use mysterious\productlayout\classes\font;
class shortcodes
{
    private static $_instance = null;

    public function __construct()
    {
        $shortcodes = array(
            'mst_cplfvc_list_categories' 				=> 'categoriesShortcode',
            'mst_cplfvc_list_product' 					=> 'productShopShortcode',
            'mst_cplfvc_product_name_category' 			=> 'archiveNameShortCode',
            'mst_cplfvc_product_description_category' 	=> 'archiveDescShortcode',
			'mst_cplfvc_product_category' 				=> 'archiveProductShortCode',
            'mst_cplfvc_product_category_filter' 		=> 'categoryFilterShortcode',
            'mst_cplfvc_product_images' 				=> 'productImageShortcode',
            'mst_cplfvc_product_title' 					=> 'productTitleShortcode',
            'mst_cplfvc_product_rating' 				=> 'productRatingShortcode',
            'mst_cplfvc_product_price' 					=> 'productPriceShortcode',
            'mst_cplfvc_product_share' 					=> 'productShareShortcode',
            'mst_cplfvc_product_excert' 				=> 'productExcertShortcode',
            'mst_cplfvc_product_add_to_cart' 			=> 'productAddToCartShortcode',
            'mst_cplfvc_product_cat_product_single' 	=> 'productMetaShortcode',
            'mst_cplfvc_product_description' 			=> 'productDescriptionShortcode',
            'mst_cplfvc_product_review' 				=> 'productReviewShortcode',
            'mst_cplfvc_product_additional_information' => 'productAddInfoShortcode',
            'mst_cplfvc_product_show_tab' 				=> 'productDataTabShortcode',
            'mst_cplfvc_product_relate' 				=> 'productRelateShortcode',
			'mst_cplfvc_product_upsell' 				=> 'productUpsellShortcode',
			'mst_cplfvc_product_name_tag' 				=> 'archiveNameShortCode',
			'mst_cplfvc_product_description_tag' 		=> 'archiveDescShortcode',
            'mst_cplfvc_product_tags' 					=> 'archiveProductShortCode',
			'mst_cplfvc_product_name_brand' 			=> 'archiveNameShortCode',
			'mst_cplfvc_product_description_brand' 		=> 'archiveDescShortcode',
            'mst_cplfvc_product_brand' 					=> 'archiveProductShortCode',
			'mst_cplfvc_product_name_attribute' 		=> 'archiveNameShortCode',
			'mst_cplfvc_product_description_attribute' 	=> 'archiveDescShortcode',
            'mst_cplfvc_product_attribute' 				=> 'archiveProductShortCode'
        );
		if( productLayoutWPB()->currentTheme() === 'electro' )
		{
			$shortcodes['mst_cplfvc_product_availability'] 		= 'productAvailabilityShortcode';
			$shortcodes['mst_cplfvc_product_categories'] 		= 'productCategoryShortcode';
			$shortcodes['mst_cplfvc_product_add_to_wishlist'] 	= 'productAddToWishlist';
		}
        foreach ($shortcodes as $shortcode => $shorecode_name_function){
            add_shortcode($shortcode, array(&$this, $shorecode_name_function));
        }
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    protected function _shortcode_atts($defaults = array(), $atts)
    {
        if (isset($atts['class'])) {
            $atts['classname'] = $atts['class'];
        }
        return \shortcode_atts($defaults, $atts);
    }
	// SHOP
    public function categoriesShortcode($atts,$content=null)
	{
        extract ( $this->_shortcode_atts ( array (
			'number' => '',
		    'columns'  => '3',
		    'orderby'  => 'rand',
		    'order'    => 'asc'
		), $atts ) );
		ob_start ();
		?>
		<?php
		if(productLayoutWPB()->is_product_layout('shop')){
			echo "<div class='mstcplfwpb-product-categories'>";
			echo do_shortcode("[product_categories orderby=".$orderby." order=".$order." columns=".$columns." number=".$number." ids='' ]");
			echo "</div>";
		}
		return ob_get_clean ();
    }

    public function productShopShortcode($atts,$content=null)
	{
		extract ( $this->_shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start();
		if(productLayoutWPB()->is_product_layout('shop')){
			$this->archiveFilterDefault($el_class);
		}
		return ob_get_clean ();
    }
	
	public function archiveNameShortCode( $atts,$content = null )
	{
		extract ( $this->_shortcode_atts ( array (
			'tag'			=> 'h2',
			'text_align'	=> 'left',
			'font_size'		=> '',
			'line_height'	=> '',
			'color'			=> '',
			'use_fonts'		=> 'yes',
			'google_fonts'	=> 'font_family:Abril Fatface|font_style:400 regular',
			'el_class'		=> ''
		), $atts ) );
		ob_start ();
			$archive = productLayoutWPB()->get_archive();
			if($archive)
			{
				$name		= isset($archive['term']->name) ? $archive['term']->name : '';
				$font_size	= !empty($font_size) ? $font_size : 'xxx-large';
				$color		= !empty($color) ? $color : '#000000';
				$style_css 	= "--tooltip-color: ".$color.";--tooltip-size: ".$font_size.";--tooltip-text-align: ".$text_align;
				$font_style = new font();
				if (!empty($el_class)) {
					echo '<div class="'.esc_attr($el_class).'">';
				}
				if(isset($atts['use_fonts']) && $atts['use_fonts']=='no'){
					$text_font_data = $font_style->getFontsData( $google_fonts );
					$text_font_inline_style = $font_style->googleFontsStyles( $text_font_data );   
					$style_css = $text_font_inline_style.$style_css;
					$font_style->enqueueGoogleFonts( $text_font_data );	
				}
				echo sprintf('<%1$s class="mstcplfwpb-category-name" style="%2$s">%3$s</%1$s>',
						esc_attr($tag),
						esc_attr($style_css),
						esc_html($name)
                );
				if (!empty($el_class)) {
					echo '</div>';
				}
			}
		
		return ob_get_clean ();
	}

	public function archiveDescShortcode( $atts,$content = null )
	{
		extract ( $this->_shortcode_atts ( array (
            'size' 			=> 'inherit',
			'text_align' 	=> 'left',
            'color' 		=>'',
            'use_fonts'		=> 'yes',
            'google_fonts'	=>'font_family:Abril Fatface|font_style:400 regular',
            'el_class'		=> '',
        ), $atts ) );
		ob_start ();
		$font_style = new font();
		$term_id 	= productLayoutWPB()->get_term_id();
		$font_size	= !empty($size) ? $size : 'inherit';
		$color		= !empty($color) ? $color : 'inherit';
		$style_css 	= "--tooltip-color: ".$color.";--tooltip-size: ".$font_size.";--tooltip-align: ".$text_align;
        if (!empty($el_class)) {
            echo '<div class="'.esc_attr($el_class).'">';
		}
		if(isset($atts['use_fonts']) && $atts['use_fonts']=='no')
		{
			$text_font_data 			= $font_style->getFontsData( $google_fonts );
			$text_font_inline_style 	= $font_style->googleFontsStyles( $text_font_data );
			$style_css 					= $text_font_inline_style.$style_css;
			$font_style->enqueueGoogleFonts( $text_font_data );
		}
		echo sprintf('<div class="mstcplfwpb-description-category" style="%1$s">%2$s</div>',
				esc_attr($style_css),
				category_description($term_id)
        );
        if (! empty ( $el_class ) ){
			echo '</div>';
		}
        return ob_get_clean ();
	}

	public function archiveProductShortCode($atts,$content=null)
	{
		extract ( $this->_shortcode_atts ( array (
		    'columns'  => '3',
		    'orderby'  => 'rand',
		    'order'    => 'asc',
			'el_class' => ''
		), $atts ) );
		ob_start ();
		$archives = array('category','tags','brand','attribute');
		foreach( $archives as $key => $type )
		{
			if( productLayoutWPB()->is_product_layout($type) )
			{
				$is_theme = productLayoutWPB()->currentTheme();
				$el_class = $is_theme === 'storefront' ? $el_class.' mstcplfwpb-product-category-storefront' : $el_class;
				$classCss = $is_theme === 'dt-the7' ? $el_class  : 'mstcplfwpb-product-category mstcplfwpb-product-category-'.$columns.' '.$el_class;
				echo '<div class="'.esc_attr($classCss).'">';
				if ( woocommerce_product_loop() ) 
				{
					$this->woocommerce_product_sorting();
					woocommerce_product_loop_start();
					if ( wc_get_loop_prop( 'total' ) ) {
						while ( have_posts() ) {
							the_post();
							if($is_theme !=='electro'){
								do_action( 'woocommerce_shop_loop' );
							}
							wc_get_template_part( 'content', 'product' );
						}
					}
					woocommerce_product_loop_end();
					$this->woocommerce_pagination();
				} else {
					do_action( 'woocommerce_no_products_found' );
				}
				echo '</div>';
				break;
			}
		}	
		return ob_get_clean ();
	}

	public function archiveFilterDefault($el_class)
	{
		$is_theme = productLayoutWPB()->currentTheme();
		$classRow = $is_theme === 'specular' ? 'mstcplfwpb-specular' : '';
		echo '<div class="'.esc_attr($classRow).' '.esc_attr($el_class).'">';
		if ( woocommerce_product_loop() ) {
				$this->woocommerce_product_sorting();
				woocommerce_product_loop_start();
				if ( wc_get_loop_prop( 'total' ) ) {
					while ( have_posts() ) {
						the_post();
						if($is_theme !=='electro'){
							do_action( 'woocommerce_shop_loop' );
						}
						wc_get_template_part( 'content', 'product' );
					}
				}
				woocommerce_product_loop_end();
				$this->woocommerce_pagination();
		} else {
			do_action( 'woocommerce_no_products_found' );
		}
		echo '</div>';
	}
	// PRODUCT CATEGORY
   
    public function categoryFilterShortcode($atts,$content=null)
	{
		extract ( $this->_shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start();
		if(productLayoutWPB()->is_product_layout('category')){
			$this->archiveFilterDefault($el_class);
		}
		return ob_get_clean ();
	}
	// PRODUCT
    public function productImageShortcode($atts,$content=null){
        global $product, $post;
		extract ( $this->_shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
		
			if(class_exists('JCKWooThumbs'))
			{
				$JCKWooThumbs = new \JCKWooThumbs;
				$JCKWooThumbs->show_product_images();
			}
			else if(class_exists('WC_Product_Gallery_slider'))
			{
				$enabled = get_option( 'woocommerce_product_gallery_slider_enabled' );
				$enabled_for_post   = get_post_meta( $post->ID, '_woocommerce_product_gallery_slider_enabled', true );
				if ( ( $enabled == 'yes' && $enabled_for_post !== 'no' ) || ( $enabled == 'no' && $enabled_for_post == 'yes' ) ) {
					\WC_Product_Gallery_slider::setup_scripts_styles();
					\WC_Product_Gallery_slider::show_product_gallery();
				}
			}
			else
			{
				$is_theme = productLayoutWPB()->currentTheme();
				switch ($is_theme) {
					case 'thegem':
						remove_action('thegem_woocommerce_single_product_left', 'thegem_socials_sharing', 10);
						remove_action('thegem_woocommerce_single_product_left', 'woocommerce_template_single_meta', 15);
						do_action('thegem_woocommerce_single_product_left');
						break;
					case 'shopkeeper':
						echo '<div class="product-images-wrapper">';
						do_action( 'woocommerce_before_single_product_summary_product_images' );
						do_action( 'woocommerce_before_single_product_summary' );
						echo '<div class="product-badges">';
						echo '<div class="product-sale">';
						do_action( 'woocommerce_before_single_product_summary_sale_flash' );
						echo '</div></div></div>';
						break;
					default:
						woocommerce_show_product_sale_flash();
						woocommerce_show_product_images ();
						break;
				}
				
			}
			if (! empty ( $el_class ))
				echo '</div>';
		}
		return ob_get_clean ();
    }
    public function productTitleShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
			'el_class'=>''
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
			woocommerce_template_single_title();
			if (! empty ( $el_class )){
				echo '</div>';
			}	
		}
		return ob_get_clean ();
    }
    public function productRatingShortcode($atts,$content=null){
        global $post,$product;
		extract ( $this->_shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
				woocommerce_template_single_rating();
			if (! empty ( $el_class ))
				echo '</div>';
		}
		return ob_get_clean ();
    }
    public function productPriceShortcode($atts,$content=null){
        global $post,$product;
		extract ( $this->_shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
			woocommerce_template_single_price();
			if (! empty ( $el_class )){
				echo '</div>';
			}
		}
		return ob_get_clean ();
    }
    public function productShareShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
            'el_class'=>'',
        ), $atts ) );
        ob_start();
        global $post,$product;
        $share_url = get_permalink(get_the_ID());
        $posttitle = get_the_title(get_the_ID());
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
		?>	
            <a href="#" title="Twitter" class="mstcplfwpb-icon-button twitter" onclick="javascript: window.open('<?php echo 'https://twitter.com/home?status='.$posttitle.'&nbsp;'.$share_url; ?>'); return false;" target="_blank"><i class="icon-twitter"></i><span></span></a>
            <a href="#" class="mstcplfwpb-icon-button facebook" onclick="javascript: window.open('<?php echo 'https://www.facebook.com/sharer/sharer.php?u='.$share_url; ?>'); return false;" title="Facebook" target="_blank"><i class="icon-facebook"></i><span></span></a>
            <a href="#" class="mstcplfwpb-icon-button google-plus" onclick="javascript: window.open('<?php echo 'https://plus.google.com/share?url='.$share_url; ?>'); return false;" title="Google +" target="_blank"><i class="icon-google-plus"></i><span></span></a>
            <a href="#" class="mstcplfwpb-icon-button google-plus" onclick="javascript: window.open('<?php echo 'https://www.linkedin.com/shareArticle?mini=true&amp;url='.$share_url.'&amp;title='.$posttitle; ?>'); return false;" title="LinkedIn" target="_blank"><i class="icon-linkedin"></i><span></span></a>
        <?php
			if (! empty ( $el_class )){
				echo '</div>';
			}
            
		}
        return ob_get_clean();
    }
    public function productExcertShortcode($atts,$content=null){
        global $post,$product;
		extract ( $this->_shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
			woocommerce_template_single_excerpt();
			if (! empty ( $el_class )){
				echo '</div>';
			}
		} 
		return ob_get_clean ();
    }
    public function productAddToCartShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
            'el_class' => '' 
        ), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
			woocommerce_template_single_add_to_cart ();
			if (! empty ( $el_class ))
				echo '</div>';
		}
        return ob_get_clean ();
    }
    public function productMetaShortcode($atts,$content=null){
        global $post,$product;
		extract ( $this->_shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
				woocommerce_template_single_meta ();  
			if (! empty ( $el_class ))
				echo '</div>';
		}
		return ob_get_clean ();
    }
    public function productDescriptionShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
            'el_class' => '',
        ), $atts ) );
	    ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
			the_content();
			if (! empty ( $el_class )){
				echo '</div>';
			}
		} 
		return ob_get_clean ();
    }
    public function productReviewShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
			if(comments_open() ){
				comments_template();
			}
			if (! empty ( $el_class ))
				echo '</div>';
		}
		return ob_get_clean ();
    }
    public function productAddInfoShortcode($atts,$content=null){
        global $product, $post;
		extract ( $this->_shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';

			if ( $product && ( $product->has_attributes() || ( $product->enable_dimensions_display() && ( $product->has_dimensions() || $product->has_weight() ) ) ) ) {
				wc_get_template( 'single-product/tabs/additional-information.php' );
			}

			if (! empty ( $el_class ))
				echo '</div>';
		}
		return ob_get_clean ();
    }
    public function productDataTabShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
            'el_class' => '' 
        ), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('single'))
		{
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
				woocommerce_output_product_data_tabs ();
			if (! empty ( $el_class ))
				echo '</div>';
		}
        return ob_get_clean ();
    }

    public function productRelateShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
            'posts_per_page'	=> 3,
            'columns'			=> 3,
            'orderby'			=> 'rand',
            'el_class' 			=> ''
        ), $atts ) );
		ob_start ();
		
		if(productLayoutWPB()->is_product_layout('single'))
		{
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
			echo '<div class="mstcplfwpb-product-related mstcplfwpb-product-related-columns-'.$columns.'">';
			echo woocommerce_related_products($atts);
			echo '</div>';
			if (! empty ( $el_class )){
				echo '</div>';
			}
			
		}
        return ob_get_clean ();
    }
    public function productUpsellShortcode($atts,$content=null){
        extract ( $this->_shortcode_atts ( array (
            'posts_per_page'	=> 4,
            'columns'			=> 3,
            'orderby'			=> 'date',
            'el_class' 			=> ''
        ), $atts ) );
        ob_start ();

		if(productLayoutWPB()->is_product_layout('single'))
		{
			if (! empty ( $el_class )){
				echo '<div class="'.esc_attr($el_class).'">';
			}
			echo '<div class="mstcplfwpb-product-upsell mstcplfwpb-product-upsell-columns-'.$columns.'">';
			woocommerce_upsell_display ( $posts_per_page, $columns, $orderby);
			echo '</div>';
			if (! empty ( $el_class )){
				echo '</div>';
			}
				
		}
        return ob_get_clean ();
	}
	
	public function productAvailabilityShortcode($atts,$content=null)
	{
        extract ( $this->_shortcode_atts ( array (
            'el_class' => '' 
        ), $atts ) );
		ob_start ();
		if( productLayoutWPB()->is_product_layout('single') )
		{
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
				if ( function_exists( 'electro_template_loop_availability' ) ) {
					electro_template_loop_availability();
				}
			if (! empty ( $el_class ))
				echo '</div>';
		}
        return ob_get_clean ();
    }

	public function productCategoryShortcode($atts,$content=null)
	{
		extract ( $this->_shortcode_atts ( array (
            'el_class' => '' 
        ), $atts ) );
		ob_start ();
		
		if(productLayoutWPB()->is_product_layout('product')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
				if ( function_exists( 'electro_template_loop_categories' ) ) {
					electro_template_loop_categories();
				}
			if (! empty ( $el_class ))
				echo '</div>';
		}
        return ob_get_clean ();
		
	}

	public function productAddToWishlist($atts,$content=null)
	{
		extract ( $this->_shortcode_atts ( array (
            'el_class' => '' 
        ), $atts ) );
		ob_start ();
		if(productLayoutWPB()->is_product_layout('product')){
			if (! empty ( $el_class ))
				echo '<div class="'.esc_attr($el_class).'">';
				if ( function_exists( 'electro_loop_action_buttons' ) ) {
					electro_loop_action_buttons();
				}
			if (! empty ( $el_class ))
				echo '</div>';
		}
        return ob_get_clean ();
	}

	//UPDATE 19/12/2020
	public function woocommerce_product_sorting()
	{
		$theme_active = productLayoutWPB()->currentTheme();
		switch ($theme_active)
		{
			case 'boxshop':
				echo '<div class="before-loop-wrapper">';
				do_action( 'woocommerce_before_shop_loop' );
				echo '</div>';
				break;
			case 'minera':
				$view_style = get_theme_mod( 'c_shop_view_style', 'grid' );
				echo '<div class="woo-top-page flw">';
				do_action( 'woocommerce_before_shop_loop' );
                minera_shop_switcher($view_style);
				echo '</div>';
				break;
			case 'amely':
				echo '<div class="shop-loop-head row">';
				echo '<div class="shop-display col-xl-7 col-lg-6">';
				woocommerce_result_count();
				echo '</div>';
				echo '<div class="shop-filter col-xl-5 col-lg-6">';
				woocommerce_catalog_ordering();
				echo '</div>';
				echo '</div>';
				break;
			case 'woodmart':
				echo '<div class="shop-loop-head">';
				echo '<div class="woodmart-woo-breadcrumbs">';
				woocommerce_result_count(); 
				echo '</div>';
				echo '<div class="woodmart-shop-tools">';
				do_action( 'woocommerce_before_shop_loop' );
				echo '</div>';
				echo '</div>';
				break;
			case 'shopkeeper':
				$display_mode 	= woocommerce_get_loop_display_mode();
				?>
				<div class="tob_bar_shop">
					<div class="small-5 medium-7 large-6 xlarge-8 columns text-left">
						<?php if( is_active_sidebar( 'catalog-widget-area') ) : ?>
							<div id="button_offcanvas_sidebar_left"  data-toggle="offCanvasLeft1">
								<span class="filters-text">
									<i class="spk-icon spk-icon-menu-filters"></i>
									<?php echo esc_html_e( 'Filter', 'woocommerce' ); ?>
								</span>
							</div>
						<?php endif; ?>
						<?php do_action('woocommerce_before_main_content_breadcrumb');?>
					</div>
					<?php if( 'subcategories' != $display_mode ): ?>
						<div class="small-7 medium-5 large-6 xlarge-4 columns text-right">
							<div class="catalog-ordering <?php echo (!\Shopkeeper_Opt::getOption( 'archive_product_count', false )) ? 'hide-results' : ''; ?>">
								<?php
									do_action( 'woocommerce_before_shop_loop_catalog_ordering' );
									do_action( 'woocommerce_before_shop_loop_result_count' );
								?>
							</div>
						</div>
					<?php endif; ?>
				</div><?php
				break;
			default:
				do_action( 'woocommerce_before_shop_loop' );
				break;
		}
	}

	public function woocommerce_pagination()
	{
		$theme_active = productLayoutWPB()->currentTheme();
		switch ($theme_active) {
			case 'boxshop':
				echo '<div class="after-loop-wrapper">';
				do_action( 'woocommerce_after_shop_loop' );
				echo '</div>';
				break;
			default:
				do_action( 'woocommerce_after_shop_loop' );
				break;
		}
	}
}