<?php
namespace mysterious\productlayout\controllers;
use function mysterious\productlayout\productLayoutWPB;
class backend
{
    private static $_instance = null;
    public $post_type = false;
    public function __construct(){
        $this->post_type = productLayoutWPB()->get_post_type();
        
        add_action('init', array($this, 'custom_rewrite_rule_tag'), 10, 0);
        add_action('parse_request', array($this, 'callback_set_url_product_layout'));
        add_filter('vc_add_element_categories',array($this,'callback_add_categories_template'));
        add_action('admin_enqueue_scripts', array($this, 'callback_add_list_element'));
        // CUSTOM POST TYPE
        add_action('admin_init', array($this, 'set_cap'));
        add_action('admin_print_scripts-post-new.php', array($this, 'admin_print_scripts_posttype'), 9999);
        add_action('admin_print_scripts-post.php', array($this, 'admin_print_scripts_posttype'), 9999);
        add_action('admin_print_styles-post-new.php', array($this, 'admin_print_styles_posttype'), 9999);
        add_action('admin_print_styles-post.php', array($this, 'admin_print_styles_posttype'), 9999);
        add_filter('enter_title_here',  array($this, 'enter_title_here'), 9999);
        add_action('edit_form_after_title', array($this, 'edit_form_after_title'));
        add_filter('wpb_vc_js_status_filter', array($this, 'wpb_vc_js_status_filter'));
        //Create New Param Type
        vc_add_shortcode_param( 'mst_layout_label', array($this, 'add_shortcode_param') );
    }
    public static function instance(){
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    public function custom_rewrite_rule_tag(){
        $routes = array(
            'export-template' => array(
                'url' => 'export-template-product-layout',
                'var' => 'export-file-json-product-layout',
                'tag_regex' => '[^&]+',
            ),
        );
        foreach ($routes as $k => $v) {
            add_rewrite_rule('^' . $v['url'] . '/?', 'index.php?' . $v['var'], 'top');
        }
        foreach ($routes as $k => $v) {
            add_rewrite_tag('%' . $v['var'] . '%', '(' . $v['tag_regex'] . ')');
        }
        flush_rewrite_rules();
    }

    public function callback_set_url_product_layout($wp){
        if (array_key_exists('export-file-json-product-layout', $wp->query_vars)) {
            $language = isset($_GET['language']) && !empty($_GET['language']) ? sanitize_text_field($_GET['language']) : "";
            $template_export = $this->get_template_export_product_layout($language);
            $filename = !empty($language) ? "product_layout_template_".$language."_" . time() . ".json" : "product_layout_template_" . time() . ".json";
            header('Content-Type: application/json');
            header('Content-Disposition: attachment; filename="' . $filename . '";');
            $fp = fopen('php://output', 'w');
            fwrite($fp, json_encode($template_export, JSON_PRETTY_PRINT));
            fclose($fp);
            exit();
        }
        return;
    }
    
    public function get_template_export_product_layout($language){
        $template_export = array();
        $types = array("shop","category","single","tags");
        foreach($types as $type){
            $table = productLayoutWPB()->get_table_by_type_template($type);
            $layouts = productLayoutWPB()->get_list_template_by_language($table,$language);
            if ($layouts) {
                foreach ($layouts as $key => $template) {
                    $template_export[$type][$key]["title"] = $template->title;
                    $template_export[$type][$key]["images"] = $template->images;
                    $template_export[$type][$key]["content"] = $template->content;
                    $template_export[$type][$key]["language"] = $language;
                    $template_export[$type][$key]["active"] = 0;
                }
            }
        }
        return $template_export;
    }

    public function callback_add_categories_template($tabs){
        $tabs[] = array(
            'name' => __('Product Layout',MST_CPLFVC),
            'filter' => '.js-category-pl-tab',
            'active' => ''
          );
          return $tabs;
    }

    public function callback_add_list_element(){
        ob_start();
        $elements = productLayoutWPB()->get_elements();
        ?>
        <li data-element="" class="wpb-layout-element-button vc_col-xs-12 vc_col-sm-12 vc_col-md-12 vc_col-lg-12 js-category-pl-tab vc_visible" data-vc-ui-element="add-element-button">
            <ul class="mst_plvc-tab-panel">
                <li class="active"><a href="#mst-plvc-tab-a"><?php echo esc_html__("Shop page",MST_CPLFVC); ?></a></li>
                <li><a href="#mst-plvc-tab-b"><?php echo esc_html__("Product category page",MST_CPLFVC); ?></a></li>
                <li><a href="#mst-plvc-tab-c"><?php echo esc_html__("Product page",MST_CPLFVC); ?></a></li>
                <li><a href="#mst-plvc-tab-d"><?php echo esc_html__("Product tag page",MST_CPLFVC); ?></a></li>
                <li><a href="#mst-plvc-tab-e"><?php echo esc_html__("Product brand page",MST_CPLFVC); ?></a></li>
                <li><a href="#mst-plvc-tab-f"><?php echo esc_html__("Product attribute page",MST_CPLFVC); ?></a></li>
            </ul>
            <div class="mst_plvc-tab-content">
                <div id="mst-plvc-tab-a" class="active">
                    <?php productLayoutWPB()->show_elements($elements['shop']);?>
                </div>
                <div id="mst-plvc-tab-b">
                    <?php productLayoutWPB()->show_elements($elements['category']);?>
                </div>
                <div id="mst-plvc-tab-c">               
                    <?php productLayoutWPB()->show_elements($elements['product']);?>
                    <?php if( productLayoutWPB()->currentTheme() === 'electro' ){?>
                        <div class="vc_el-container"><a id="mst_cplfvc_product_availability" data-tag="mst_cplfvc_product_availability" class="dropable_el vc_shortcode-link" href="javascript:;" data-vc-clickable=""><i class="vc_general vc_element-icon icon-mst_cplfvc-product-single"></i> <span data-vc-shortcode-name=""><?php echo esc_html__("Product Availability",MST_CPLFVC); ?></span></a></div>
                        <div class="vc_el-container"><a id="mst_cplfvc_product_categories" data-tag="mst_cplfvc_product_categories" class="dropable_el vc_shortcode-link" href="javascript:;" data-vc-clickable=""><i class="vc_general vc_element-icon icon-mst_cplfvc-product-single"></i> <span data-vc-shortcode-name=""><?php echo esc_html__("Product Categories",MST_CPLFVC); ?></span></a></div>
                        <div class="vc_el-container"><a id="mst_cplfvc_product_add_to_wishlist" data-tag="mst_cplfvc_product_add_to_wishlist" class="dropable_el vc_shortcode-link" href="javascript:;" data-vc-clickable=""><i class="vc_general vc_element-icon icon-mst_cplfvc-product-single"></i> <span data-vc-shortcode-name=""><?php echo esc_html__("Add To Wishlist",MST_CPLFVC); ?></span></a></div>
                    <?php }?>
                </div>
                <div id="mst-plvc-tab-d">
                    <?php productLayoutWPB()->show_elements($elements['tags']);?>  
                </div>
                <div id="mst-plvc-tab-e">
                    <?php productLayoutWPB()->show_elements($elements['brand']);?>  
                </div>
                <div id="mst-plvc-tab-f">
                    <?php productLayoutWPB()->show_elements($elements['attribute']);?>  
                </div>
            </div>
        </li>
        <?php
            $include_scripts = ob_get_clean();
            wp_enqueue_style('mstcplfwpb-tabs');
            wp_enqueue_script('mstcplfwpb-tabs');
            wp_localize_script('mstcplfwpb-tabs', 'mstcplfwpb_tab_data',
                array(
                  'shortcode' => $include_scripts
                )
            );
    }

    // CUSTOM POST TYPE
    public function admin_print_scripts_posttype(){
        global $post;
        if ($post->post_type === $this->post_type ) {
            $data_localize_script                           = productLayoutWPB()->get_localize_script();
            $data_localize_script['post_id']                = $post->ID;
            $template_id                                    = isset($_GET['edit']) && !empty($_GET['edit']) ? sanitize_text_field($_GET['edit']) : false;
            $type_template                                  = isset($_GET['type']) && !empty($_GET['type']) ? sanitize_text_field($_GET['type']) : false;
            $data_localize_script['vc_template_custom_css'] = $template_id ? productLayoutWPB()->show_post_css($type_template,$template_id) : '';
            wp_dequeue_script('autosave');
            wp_enqueue_script('mstcplfwpb-posttype',MST_CPLFVC_URL.'assets/js/posttype.js',array('jquery'),MST_CPLFVC_VERSION);
            wp_localize_script(
                'mstcplfwpb-posttype',
                'mst_product_layout_data',
                $data_localize_script
            );
        }
    }
    public function admin_print_styles_posttype(){
        global $post;
        if ($post->post_type === $this->post_type ) {
            wp_enqueue_style('mstcplfwpb-editing-posttype', MST_CPLFVC_URL . 'assets/css/posttype.css', array(), MST_CPLFVC_VERSION);
            wp_dequeue_script('autosave');
        }
    }

    public function enter_title_here($input){
        if ( $this->post_type === get_post_type() ) {
            $input = esc_html__('Template name', MST_CPLFVC );
        }
        return $input;
    }
    public function set_cap(){
        $post_types = vc_editor_post_types();
        if (!in_array($this->post_type, $post_types)) {
            $post_types[] = $this->post_type;
            vc_editor_set_post_types($post_types);
        }
    }
    public function wpb_vc_js_status_filter($status){
        global $post;
        if ($post->post_type == $this->post_type) {
            return 'true';
        }
        return $status;
    }
    
    public function edit_form_after_title(){
        global $post;
        if (is_admin() && $post->post_type == $this->post_type) {
            $type_template      = isset($_GET['type']) && !empty($_GET['type']) ? sanitize_text_field($_GET['type']) : false;
            $template_id        = isset($_GET['edit']) && !empty($_GET['edit']) ? sanitize_text_field($_GET['edit']) : '0';
            $template_id        = intval($template_id);
            $info_by_template   = productLayoutWPB()->get_info_by_id($type_template,$template_id);
            $post->post_content = isset($info_by_template['content']) ? $info_by_template['content'] : '';
        }
    }
    public function add_shortcode_param($settings, $value){
        return '';
    }
}